#ifndef _FTDIDRV_H_
#define _FTDIDRV_H_

#include "trom.h"

class FtdiDrv : public TROM {
	public:
		FtdiDrv();
		virtual ~FtdiDrv();

		bool Init();
		void Write(bool wr);
		void Inc(bool i);
		void SCK(bool c);
		void SDA(bool d);
		bool SFB();

	private:
		struct ftdi_context *ftdi;
		unsigned char buffer[256];
		unsigned char last;
		int pos;

		void SetBit(int i, bool b);
		void SendBits(unsigned char b);
		void Flush();
		void FtdiError();
		void FtdiFatal();
};

#endif
