#include <stdio.h>
#include <sys/io.h>
#include <unistd.h>

#include "ppdrv.h"

#define _WR(x)	wrbit(port, 0, x)
#define _INC(x)	wrbit(port, 1, x)
#define _SCK(x)	wrbit(port, 2, x)
#define _SDA(x)	wrbit(port, 3, x)
#define _SFB()	!rdbit(port+1, 7)

const PPDrv::port_t PPDrv::PP_address[] = {0x378, 0x278, 0x3BC};

bool PPDrv::Open(port_t _port) {
	port = _port;

	if (ioperm(port, 3, 1) || (port != 0x3BC && ioperm(port + 0x402, 1, 1))) {
		fprintf(stderr, "Can't access parallel port!\n");
		return false;
	}

	if (port != 0x3BC) {
		// postavi standardni mod
		outb(0x00, port + 0x402);
	}

	outb(oldd = 0x5A, port);
	delay();
	if (inb(port) != oldd) goto modiferr;
	outb(oldd = 0xA5, port);
	delay();
	if (inb(port) != oldd) goto modiferr;

	return true;

modiferr:
	fprintf(stderr, "Strange error - can't modify parallel port data!\n");
	return false;
}

void PPDrv::Write(bool wr) { _WR(wr);	delay();}
void PPDrv::Inc(bool i) { _INC(i);	delay();}
void PPDrv::SCK(bool c) { _SCK(c);	delay();}
void PPDrv::SDA(bool d) { _SDA(d);	delay();}
bool PPDrv::SFB() { return _SFB(); }

void PPDrv::wrbit(port_t p, int b, int set) {
	byte_t mask = 1 << b;
	if (set && !(oldd & mask)) {
		outb(oldd |= mask, p);
	} else if (!set && (oldd & mask)) {
		outb(oldd &= ~mask, p);
	}
	delay();
}

PPDrv::byte_t PPDrv::rdbit(port_t p, int b) {
	return inb(p) & (1 << b);
}

void PPDrv::delay() const {
	//usleep(2);
}
