#ifndef _PPDRV_H_
#define _PPDRV_H_

#include "trom.h"

class PPDrv : public TROM {
	public:
		typedef unsigned short int port_t;
		
		static const port_t PP_address[];

		virtual ~PPDrv() {}

		bool Open(port_t port);

	protected:
		void Write(bool wr);
		void Inc(bool i);
		void SCK(bool c);
		void SDA(bool d);
		bool SFB();

	private:
		typedef unsigned char byte_t;

		port_t port;
		byte_t oldd;

		void wrbit(port_t p, int b, int set);
		byte_t rdbit(port_t p, int b);
		void delay() const;
};

#endif
