#ifndef _TROM_H_
#define _TROM_H_

#include <stdio.h>

class TROM {
	public:
		typedef unsigned char byte_t;
		typedef void (*sendcallback)(unsigned long sent, unsigned long tosend, void *arg);

		virtual ~TROM() {}

		virtual bool Init();
		bool Test();
		void SendData(const void *d, unsigned long size, unsigned long ofs = 0, sendcallback sb = NULL, void *arg = NULL);
		virtual void Shutdown();

	protected:
		virtual void Write(bool wr) = 0;
		virtual void Inc(bool i) = 0;
		virtual void SCK(bool c) = 0;
		virtual void SDA(bool d) = 0;
		virtual bool SFB() = 0;

	private:
		bool wr_mode;
		byte_t cur_ha;

		void WriteMode(bool wr);
		void SetData(byte_t d);
		byte_t GetData();
		void SetHighAddr(byte_t ha);
		void SetHighAddr(byte_t ha, bool ce2);
		void SetAddress(unsigned short int addr);
		void SetAddress15(unsigned short int addr, bool ce);
};

#endif
